/* eslint-disable */
const Interface = require('./lib/interface');

class TestInterface {
  method1() { }
  method2() { }
  method3WithParams(foo, bar, baz) { }
  method4(quiz) { }
}

class TestStrictImpl extends Interface.StrictInterface(TestInterface) {
  method1() { }
  method3WithParams(foo, bar, baz) { }
}

class InheritTestStrictImpl extends TestStrictImpl {
  method1(foo) { }
  method2() { }
}

class InheritMoreTestStrictImpl extends InheritTestStrictImpl {
  method1() { }
}

class EvenMoreTestStrictImpl extends InheritMoreTestStrictImpl {
  method4(quiz) { }
}

while (true) {
  [
    TestStrictImpl,
    InheritTestStrictImpl,
    InheritMoreTestStrictImpl,
    EvenMoreTestStrictImpl
  ].forEach((cls) => {
    console.log(`${cls.name.toString()}: ${Interface.check(cls)}`);
    try {
      console.log(new cls());
    } catch (ex) {
      console.log(ex.message);
      console.log(ex.errors);
    }
  });

  break;
}
